<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>EDMA3 Resource Manager: edma3_log.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>edma3_log.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * edma3_log.h</span>
<a name="l00003"></a>00003 <span class="comment"> *</span>
<a name="l00004"></a>00004 <span class="comment"> * EDMA3 logging/tracing service</span>
<a name="l00005"></a>00005 <span class="comment"> *</span>
<a name="l00006"></a>00006 <span class="comment"> * Copyright (C) 2009 Texas Instruments Incorporated - http://www.ti.com/</span>
<a name="l00007"></a>00007 <span class="comment"> *</span>
<a name="l00008"></a>00008 <span class="comment"> *</span>
<a name="l00009"></a>00009 <span class="comment"> *  Redistribution and use in source and binary forms, with or without</span>
<a name="l00010"></a>00010 <span class="comment"> *  modification, are permitted provided that the following conditions</span>
<a name="l00011"></a>00011 <span class="comment"> *  are met:</span>
<a name="l00012"></a>00012 <span class="comment"> *</span>
<a name="l00013"></a>00013 <span class="comment"> *    Redistributions of source code must retain the above copyright</span>
<a name="l00014"></a>00014 <span class="comment"> *    notice, this list of conditions and the following disclaimer.</span>
<a name="l00015"></a>00015 <span class="comment"> *</span>
<a name="l00016"></a>00016 <span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span>
<a name="l00017"></a>00017 <span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span>
<a name="l00018"></a>00018 <span class="comment"> *    documentation and/or other materials provided with the</span>
<a name="l00019"></a>00019 <span class="comment"> *    distribution.</span>
<a name="l00020"></a>00020 <span class="comment"> *</span>
<a name="l00021"></a>00021 <span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span>
<a name="l00022"></a>00022 <span class="comment"> *    its contributors may be used to endorse or promote products derived</span>
<a name="l00023"></a>00023 <span class="comment"> *    from this software without specific prior written permission.</span>
<a name="l00024"></a>00024 <span class="comment"> *</span>
<a name="l00025"></a>00025 <span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span>
<a name="l00026"></a>00026 <span class="comment"> *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span>
<a name="l00027"></a>00027 <span class="comment"> *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span>
<a name="l00028"></a>00028 <span class="comment"> *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span>
<a name="l00029"></a>00029 <span class="comment"> *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span>
<a name="l00030"></a>00030 <span class="comment"> *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span>
<a name="l00031"></a>00031 <span class="comment"> *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00032"></a>00032 <span class="comment"> *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span>
<a name="l00033"></a>00033 <span class="comment"> *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span>
<a name="l00034"></a>00034 <span class="comment"> *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span>
<a name="l00035"></a>00035 <span class="comment"> *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00036"></a>00036 <span class="comment"> *</span>
<a name="l00037"></a>00037 <span class="comment">*/</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#ifndef _EDMA3_LOG_H_</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#define _EDMA3_LOG_H_</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &lt;std.h&gt;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &lt;log.h&gt;</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">"C"</span> {
<a name="l00047"></a>00047 <span class="preprocessor">#endif</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="comment">/*</span>
<a name="l00057"></a>00057 <span class="comment">    Note : This header file is used to BIOS logs only. For porting purposes this</span>
<a name="l00058"></a>00058 <span class="comment">           file need to replace EDMA3_LOG_EVENT macro.</span>
<a name="l00059"></a>00059 <span class="comment"></span>
<a name="l00060"></a>00060 <span class="comment">           This header file uses log format as defined by Socrates Instrumentation.</span>
<a name="l00061"></a>00061 <span class="comment">           Any change in the file will result in incorrect interpretation by Socrates Tool.</span>
<a name="l00062"></a>00062 <span class="comment"></span>
<a name="l00063"></a>00063 <span class="comment">                                  BIOS Log Format</span>
<a name="l00064"></a>00064 <span class="comment">-------------------------------------------------------------------------------</span>
<a name="l00065"></a>00065 <span class="comment">| TimeStamp | Sequence # | Event # | Event Descriptor | Data1 | Data2 | Data3 |</span>
<a name="l00066"></a>00066 <span class="comment">| (2 words) | by BIOS    | by BIOS |                  |       |       |       |</span>
<a name="l00067"></a>00067 <span class="comment">-------------------------------------------------------------------------------</span>
<a name="l00068"></a>00068 <span class="comment"></span>
<a name="l00069"></a>00069 <span class="comment">LogBuffer:          A single log buffer called DVTEvent_Log will be used for all event logs</span>
<a name="l00070"></a>00070 <span class="comment">TimeStamp:          Automatically inserted by BIOS Log_Printf4.</span>
<a name="l00071"></a>00071 <span class="comment">Sequence #:         Automatically inserted by BIOS Log_Printf4. This is used to detect data loss.</span>
<a name="l00072"></a>00072 <span class="comment">Event:              Name to uniquely identify event. This is the name that will be used in the visualization.</span>
<a name="l00073"></a>00073 <span class="comment">                    (Limitation: RTA requires the name to be a static global)</span>
<a name="l00074"></a>00074 <span class="comment">Event Descriptor:   The Event Descriptor is created using the EDMA3_DVT_DESC Macro.</span>
<a name="l00075"></a>00075 <span class="comment">                    This Macro is of the following format (see tables below for EventType and ArgType):</span>
<a name="l00076"></a>00076 <span class="comment">                    EDMA3_DVT_DESC(EventType, Arg1Type, Arg2Type, Arg3Type)</span>
<a name="l00077"></a>00077 <span class="comment"></span>
<a name="l00078"></a>00078 <span class="comment">Note: Event # is generated by BIOS based on unique String provided as input to "Log_Printf4".</span>
<a name="l00079"></a>00079 <span class="comment">This string is extracted by Sorcates via the map file.</span>
<a name="l00080"></a>00080 <span class="comment"></span>
<a name="l00081"></a>00081 <span class="comment">Note:</span>
<a name="l00082"></a>00082 <span class="comment">1. Only three pieces of data can be included in any log</span>
<a name="l00083"></a>00083 <span class="comment">2. Data needs to be included in the same order as in table.</span>
<a name="l00084"></a>00084 <span class="comment">   i.e. if logging INITIATOR, SIZE and CORR then INITIATOR</span>
<a name="l00085"></a>00085 <span class="comment">   must be in arg1, CORR in arg2 and SIZE in arg3</span>
<a name="l00086"></a>00086 <span class="comment"></span>
<a name="l00087"></a>00087 <span class="comment">Example:</span>
<a name="l00088"></a>00088 <span class="comment"></span>
<a name="l00089"></a>00089 <span class="comment">ISRx()</span>
<a name="l00090"></a>00090 <span class="comment">{</span>
<a name="l00091"></a>00091 <span class="comment">    Log_Printf4(&amp;DVTEvent_Log, "ISR1", EDMA3_DVT_DESC(EDMA3_DVT_INT_eSTART, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE,</span>
<a name="l00092"></a>00092 <span class="comment">        EDMA3_DVT_dNONE))</span>
<a name="l00093"></a>00093 <span class="comment">    :</span>
<a name="l00094"></a>00094 <span class="comment">    :</span>
<a name="l00095"></a>00095 <span class="comment">    Log_Printf4(&amp;DVTEvent_Log, "ISR1", EDMA3_DVT_DESC(EDMA3_DVT_INT_eEND, EDMA3_DVT_dSIZE, EDMA3_DVT_dNONE,</span>
<a name="l00096"></a>00096 <span class="comment">        EDMA3_DVT_dNONE), sizeof(Buffer))</span>
<a name="l00097"></a>00097 <span class="comment">}</span>
<a name="l00098"></a>00098 <span class="comment"></span>
<a name="l00099"></a>00099 <span class="comment"></span>
<a name="l00100"></a>00100 <span class="comment">*/</span>
<a name="l00101"></a>00101 <span class="keyword">extern</span> far LOG_Obj DVTEvent_Log;
<a name="l00102"></a>00102 <span class="keyword">typedef</span> <span class="keyword">enum</span>
<a name="l00103"></a>00103 {
<a name="l00104"></a>00104     EDMA3_DVT_eINT          ,   <span class="comment">/* Interrupt Event. Use this only is logging</span>
<a name="l00105"></a>00105 <span class="comment">                                       that the interrupt occurred. Use INT_START/END</span>
<a name="l00106"></a>00106 <span class="comment">                                       if tracking the entry and exit of interrupt */</span>
<a name="l00107"></a>00107     EDMA3_DVT_eINT_START,               <span class="comment">/* Enter Interrupt service routine */</span>
<a name="l00108"></a>00108 
<a name="l00109"></a>00109     EDMA3_DVT_eINT_END,             <span class="comment">/* Exit Interrupt service routine */</span>
<a name="l00110"></a>00110 
<a name="l00111"></a>00111     EDMA3_DVT_eFUNC,                    <span class="comment">/* Interrupt Event. Use this only is logging that</span>
<a name="l00112"></a>00112 <span class="comment">                                       the function was called. Use FUNC_START/END if</span>
<a name="l00113"></a>00113 <span class="comment">                                       tracking the entry and exit of function */</span>
<a name="l00114"></a>00114     EDMA3_DVT_eFUNC_START,          <span class="comment">/* Enter function service routine */</span>
<a name="l00115"></a>00115 
<a name="l00116"></a>00116     EDMA3_DVT_eFUNC_END,                <span class="comment">/* Exit function service routine */</span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118     EDMA3_DVT_ePACKET_START,            <span class="comment">/* Start of a Packet */</span>
<a name="l00119"></a>00119 
<a name="l00120"></a>00120     EDMA3_DVT_ePACKET_END,          <span class="comment">/* End of a Packet */</span>
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     EDMA3_DVT_eDATA_SND,                <span class="comment">/* An event that has a free running counter value</span>
<a name="l00123"></a>00123 <span class="comment">                                       associated with it */</span>
<a name="l00124"></a>00124     EDMA3_DVT_eDATA_SND_START,      <span class="comment">/* A COUNTER Event that has a corresponding</span>
<a name="l00125"></a>00125 <span class="comment">                                       ENDCOUNTER event */</span>
<a name="l00126"></a>00126     EDMA3_DVT_eDATA_SND_END,            <span class="comment">/* End of a STARTCOUNTER event */</span>
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     EDMA3_DVT_eDATA_RCV,                <span class="comment">/* An Event that has a value associated with it */</span>
<a name="l00129"></a>00129 
<a name="l00130"></a>00130     EDMA3_DVT_eRCV_START,               <span class="comment">/* A VALUE event that has a corresponding ENDVALUE</span>
<a name="l00131"></a>00131 <span class="comment">                                       event */</span>
<a name="l00132"></a>00132     EDMA3_DVT_eRCV_END,             <span class="comment">/* End of a STARTVALUE event */</span>
<a name="l00133"></a>00133 
<a name="l00134"></a>00134     EDMA3_DVT_eSMPL_COUNTER,            <span class="comment">/* Sample some free running counter */</span>
<a name="l00135"></a>00135 
<a name="l00136"></a>00136     EDMA3_DVT_eEVENT,                   <span class="comment">/* Events not explicitly defined above */</span>
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     EDMA3_DVT_eEVENT_START,         <span class="comment">/* Start of an Event not mentioned in the above list */</span>
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     EDMA3_DVT_eEVENT_END                <span class="comment">/* End of an Event not mentioned in the above list */</span>
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 } EDMA3_logEventType;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="keyword">typedef</span> <span class="keyword">enum</span>
<a name="l00145"></a>00145 {
<a name="l00146"></a>00146     EDMA3_DVT_dNONE ,   <span class="comment">/* No Data */</span>
<a name="l00147"></a>00147 
<a name="l00148"></a>00148     EDMA3_DVT_dINST,                    <span class="comment">/* ID for this instance of the driver. This is necessary</span>
<a name="l00149"></a>00149 <span class="comment">                                       if separate analysis is required for different instances</span>
<a name="l00150"></a>00150 <span class="comment">                                       of a multiple instance driver. */</span>
<a name="l00151"></a>00151     EDMA3_DVT_dINITIATOR,               <span class="comment">/* ID of the component that initiated this driver request */</span>
<a name="l00152"></a>00152 
<a name="l00153"></a>00153     EDMA3_DVT_dMSG_ID,              <span class="comment">/* Use to correlate START and END events. This is not</span>
<a name="l00154"></a>00154 <span class="comment">                                       necessary if  events are sequenced, i.e. no more than</span>
<a name="l00155"></a>00155 <span class="comment">                                       1 START is pending at any given time. */</span>
<a name="l00156"></a>00156     EDMA3_DVT_dCOUNTER,             <span class="comment">/* Value of a free running counter */</span>
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     EDMA3_DVT_dSIZE_BYTES,          <span class="comment">/* Size in number of bytes */</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160     EDMA3_DVT_dSIZE_WORDS,          <span class="comment">/* Size in number of words */</span>
<a name="l00161"></a>00161 
<a name="l00162"></a>00162     EDMA3_DVT_dPADD,                    <span class="comment">/* Program Address */</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     EDMA3_DVT_dDADD,                    <span class="comment">/* Data address */</span>
<a name="l00165"></a>00165 
<a name="l00166"></a>00166     EDMA3_DVT_dDATA,                    <span class="comment">/* Some Data */</span>
<a name="l00167"></a>00167 
<a name="l00168"></a>00168     EDMA3_DVT_dPACKET_ID,               <span class="comment">/* Packet ID */</span>
<a name="l00169"></a>00169 
<a name="l00170"></a>00170     EDMA3_DVT_dCHANNEL_ID               <span class="comment">/* Channel ID */</span>
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 } EDMA3_logDataDesc;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="preprocessor">#define ARG1(arg1) (arg1 &lt;&lt; 8)</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span><span class="preprocessor">#define ARG2(arg2) (arg2 &lt;&lt; 16)</span>
<a name="l00177"></a>00177 <span class="preprocessor"></span><span class="preprocessor">#define ARG3(arg3) (arg3 &lt;&lt; 24)</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>
<a name="l00179"></a>00179 <span class="preprocessor">#define EDMA3_DVT_DESC(event, arg1, arg2, arg3) (event | ARG1(arg1) | ARG2(arg2) | ARG3(arg3))</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>
<a name="l00181"></a>00181 <span class="comment">/*</span>
<a name="l00182"></a>00182 <span class="comment"> * EDMA3 Event Log Macro</span>
<a name="l00183"></a>00183 <span class="comment"> *</span>
<a name="l00184"></a>00184 <span class="comment"> * Macro to log the event</span>
<a name="l00185"></a>00185 <span class="comment"> */</span>
<a name="l00186"></a>00186 <span class="preprocessor">#define EDMA3_LOG_EVENT     LOG_printf4</span>
<a name="l00187"></a>00187 <span class="preprocessor"></span>
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="comment">/* Examples : For instrumenting a driver which is working in interrupt mode.</span>
<a name="l00190"></a>00190 <span class="comment"></span>
<a name="l00191"></a>00191 <span class="comment">Driver Write Function:</span>
<a name="l00192"></a>00192 <span class="comment"></span>
<a name="l00193"></a>00193 <span class="comment">    Drv_Write(...)</span>
<a name="l00194"></a>00194 <span class="comment">    {</span>
<a name="l00195"></a>00195 <span class="comment">        EDMA3_LOG_EVENT(hLog, "DRV", EDMA3_DVT_DESC(EDMA3_DVT_eFUNC_START, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE));</span>
<a name="l00196"></a>00196 <span class="comment">        EDMA3_LOG_EVENT(hLog, "DRV", EDMA3_DVT_DESC(EDMA3_DVT_ePACKET_START, EDMA3_DVT_dPACKET_ID, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE), packetId);</span>
<a name="l00197"></a>00197 <span class="comment"></span>
<a name="l00198"></a>00198 <span class="comment">        .</span>
<a name="l00199"></a>00199 <span class="comment">        .</span>
<a name="l00200"></a>00200 <span class="comment">        EDMA3_LOG_EVENT(hLog, "DRV", EDMA3_DVT_DESC(EDMA3_DVT_eDATA_SND_START, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE));</span>
<a name="l00201"></a>00201 <span class="comment">        .</span>
<a name="l00202"></a>00202 <span class="comment">        .</span>
<a name="l00203"></a>00203 <span class="comment">        .</span>
<a name="l00204"></a>00204 <span class="comment"></span>
<a name="l00205"></a>00205 <span class="comment">        EDMA3_LOG_EVENT(hLog, "DRV", EDMA3_DVT_DESC(EDMA3_DVT_eFUNC_END, EDMA3_DVT_dSIZE_BYTES, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE), Data Transferred);</span>
<a name="l00206"></a>00206 <span class="comment">    }</span>
<a name="l00207"></a>00207 <span class="comment"></span>
<a name="l00208"></a>00208 <span class="comment">Note: In case the driver is asychronous, then the FUNC_END event will be placed before calling</span>
<a name="l00209"></a>00209 <span class="comment">      the completion call back.</span>
<a name="l00210"></a>00210 <span class="comment"></span>
<a name="l00211"></a>00211 <span class="comment"></span>
<a name="l00212"></a>00212 <span class="comment">    DRV_ISR(...)</span>
<a name="l00213"></a>00213 <span class="comment">    {</span>
<a name="l00214"></a>00214 <span class="comment">        Case: Intermediate Transfer complete</span>
<a name="l00215"></a>00215 <span class="comment">            EDMA3_LOG_EVENT(hLog, "DRV", EDMA3_DVT_DESC(EDMA3_DVT_eDATA_SND_END, EDMA3_DVT_dSIZE_BYTES, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE), Data written to Hardware);</span>
<a name="l00216"></a>00216 <span class="comment"></span>
<a name="l00217"></a>00217 <span class="comment">        case: More Data Pending</span>
<a name="l00218"></a>00218 <span class="comment">            EDMA3_LOG_EVENT(hLog, "DRV", EDMA3_DVT_DESC(EDMA3_DVT_eDATA_SND_START, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE, EDMA3_DVT_dNONE));</span>
<a name="l00219"></a>00219 <span class="comment">    }</span>
<a name="l00220"></a>00220 <span class="comment">*/</span>
<a name="l00223"></a>00223 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00224"></a>00224 <span class="preprocessor"></span>}
<a name="l00225"></a>00225 <span class="preprocessor">#endif </span><span class="comment">/* extern "C" */</span>
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="preprocessor">#endif </span><span class="comment">/* _EDMA3_LOG_H_ */</span>
</pre></div></div>
<hr size="1"><address style="text-align: right;"><small>Generated on Tue Jul 7 19:26:47 2009 for EDMA3 Resource Manager by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
</body>
</html>
